function farrow9g
% 1-to-13 upsampling with 4-th order taylor series based farrow filter
% Script file written by fred harris of SDSU. Copyright 2002
clf
nn=159;nnp=nn+1;
hh=remez(nn,[0 .6 3.4 64]/64,[1 1 0 0],[1 4]);
stem(0:nn,hh/hh(nnp/2));grid;axis([0 nn -.2 1.2]);
pause
fhh=20*log10(fftshift(abs(fft(hh,512))));
plot(-0.5:1/512:0.5-1/512,fhh);grid
pause
ax1=axis;ax2=ax1;
ax1(1)=-.1;ax1(2)=.1;axis(ax1);
pause

stem(1:32,hh(1:32)/hh(nnp/2))
pause
hhh=hh;
d1=hh(2);d2=hh(3);
hhh(1)=d1-(d2-d1);
hhh(nnp)=hhh(1);
fhh=20*log10(fftshift(abs(fft(hhh,512))));
plot(-0.5:1/512:0.5-1/512,fhh);grid;axis(ax2);
pause
axis(ax1);
pause;


hhh=hhh/hhh(nnp/2);
vv=reshape(hhh,32,5);
p1=polyfit(0:1/32:31/32,vv(:,1)',4)
q1=polyfit(0:1/32:31/32,fliplr(vv(:,1)'),4)
pause
t1=polyval(p1,0:1/32:31/32);
u1=polyval(q1,fliplr(0:1/32:31/32));
stem(0:1/32:31/32,vv(:,1)');
hold
plot(0:1/32:31/32,t1,'c')
pause
plot(0:1/32:31/32,u1,'g')
title('weights and polynomial fit for h_n(0)') 
pause
hold
plot(0:1/32:31/32,t1-vv(:,1)');
hold
pause
plot(0:1/32:31/32,u1-vv(:,1)','g')
title('error for polynomial fit; h_n(0)') 
hold
pause

p2=polyfit(0:1/32:31/32,vv(:,2)',4);
t2=polyval(p2,0:1/32:31/32);
stem(0:1/32:31/32,vv(:,2)');
hold
plot(0:1/32:31/32,t2,'c')
title('weights and polynomial fit for h_n(1)') 
pause
hold
plot(0:1/32:31/32,t2-vv(:,2)')
title('error for polynomial fit; h_n(1)') 
pause

p3=polyfit(0:1/32:31/32,vv(:,3)',4);
t3=polyval(p3,0:1/32:31/32);
stem(0:1/32:31/32,vv(:,3)');
hold
plot(0:1/32:31/32,t3,'c')
title('weights and polynomial fit for h_n(2)') 
pause
hold
plot(0:1/32:31/32,t3-vv(:,3)')
title('error for polynomial fit; h_n(2)') 
pause

p4=polyfit(0:1/32:31/32,vv(:,4)',4);
t4=polyval(p4,0:1/32:31/32);
stem(0:1/32:31/32,vv(:,4)');
hold
plot(0:1/32:31/32,t4,'c')
title('weights and polynomial fit for h_n(3)') 
pause
hold
plot(0:1/32:31/32,t4-vv(:,4)')
title('error for polynomial fit; h_n(3)') 
pause

p5=polyfit(0:1/32:31/32,vv(:,5)',4);
t5=polyval(p5,0:1/32:31/32);
stem(0:1/32:31/32,vv(:,5)');
hold
plot(0:1/32:31/32,t5,'c')
title('weights and polynomial fit for h_n(4)') 
pause
hold
plot(0:1/32:31/32,t5-vv(:,5)')
title('error for polynomial fit; h_n(4)') 
pause

%p6=polyfit(0:1/32:31/32,vv(:,6)',4);
%t6=polyval(p6,0:1/32:31/32);
%stem(0:1/32:31/32,vv(:,6)');
%hold
%plot(0:1/32:31/32,t6,'c')
%title('weights and polynomial fit for h_n(5)') 
%pause
%hold
%plot(0:1/32:31/32,t6-vv(:,6)')
%title('error for polynomial fit; h_n(5)') 
%pause

%p7=polyfit(0:1/32:31/32,vv(:,7)',4);
%t7=polyval(p7,0:1/32:31/32);
%stem(0:1/32:31/32,vv(:,7)');
%hold
%plot(0:1/32:31/32,t7,'c')
%title('weights and polynomial fit for h_n(6)') 
%pause
%hold
%plot(0:1/32:31/32,t7-vv(:,7)')
%title('error for polynomial fit; h_n(6)') 
%pause

%p8=polyfit(0:1/32:31/32,vv(:,8)',4);
%t8=polyval(p8,0:1/32:31/32);
%stem(0:1/32:31/32,vv(:,8)');
%hold
%plot(0:1/32:31/32,t8,'c')
%title('weights and polynomial fit for h_n(7)') 
%pause
%hold
%plot(0:1/32:31/32,t8-vv(:,8)')
%title('error for polynomial fit; h_n(7)') 
pp=[p1;p2;p3;p4;p5]

subplot(2,3,1);stem(p1);title('p0');
subplot(2,3,2);stem(p2);title('p1');
subplot(2,3,3);stem(p3);title('p2');
subplot(2,3,4);stem(p4);title('p3');
subplot(2,3,5);stem(p5);title('p4');
%subplot(2,4,6);stem(p6);title('p5');
%subplot(2,4,7);stem(p7);title('p6');
%subplot(2,4,8);stem(p8);title('p7');
pause
clg
subplot(2,3,1);stem(pp(:,1));title('a4');
subplot(2,3,2);stem(pp(:,2));title('a3');
subplot(2,3,3);stem(pp(:,3));title('a2');
subplot(2,3,4);stem(pp(:,4));title('a1');
subplot(2,3,5);stem(pp(:,5));title('a0');
pause

ff=[-.5:1/64:.5-1/64];
subplot(2,3,1);plot(ff,fftshift(abs(fft(pp(:,1),64))));title('f_a4');
subplot(2,3,2);plot(ff,fftshift(abs(fft(pp(:,2),64))));title('f_a3');
subplot(2,3,3);plot(ff,fftshift(abs(fft(pp(:,3),64))));title('f_a2');
subplot(2,3,4);plot(ff,fftshift(abs(fft(pp(:,4),64))));title('f_a1');
subplot(2,3,5);plot(ff,fftshift(abs(fft(pp(:,5),64))));title('f_a0');
pause

y=0.8*sin(2*pi*(0:99)*12.5/100);
y=zeros(1,100);
y(1)=1;
zz=zeros(1,100);
yy=[zz;zz;zz;zz;zz;zz;zz;zz;zz;zz;zz;zz;zz];
size(yy);
ww=zeros(1,5);
for m=1:100
ww(2:5)=ww(1:4);
ww(1)=y(m);
bb=pp'*ww';
yy(1,m)=polyval(bb,0/13);
yy(2,m)=polyval(bb,1/13);
yy(3,m)=polyval(bb,2/13);
yy(4,m)=polyval(bb,3/13);
yy(5,m)=polyval(bb,4/13);
yy(6,m)=polyval(bb,5/13);
yy(7,m)=polyval(bb,6/13);
yy(8,m)=polyval(bb,7/13);
yy(9,m)=polyval(bb,8/13);
yy(10,m)=polyval(bb,9/13);
yy(11,m)=polyval(bb,10/13);
yy(12,m)=polyval(bb,11/13);
yy(13,m)=polyval(bb,12/13);
end
size(yy);
yyy=reshape(yy,1,1300);
clg
stem(yyy(1:70));
pause
plot(yyy)
pause
yt=yyy(50:549);
yt=yyy(1:500);
wbk=bkharris(500);
wbk=ones(1,500)';
fyt=20*log10(fftshift(abs(fft(yt.*wbk'))));plot(-.5:1/500:.5-1/500,fyt-max(fyt));grid;
axis([-.5 .5 -80 20])
hold
pause
%fyx=fhh(256-47:256+49);
fyx=fhh(256-103:256+105);
plot(-0.5:1/208:0.5,fyx,'c');