function hogen16b
% Hogenauer filter of order 3, with up-sample ratio 16
% with up-sample ratio 16 from initial 1-to-5 shaping filter
% one of suite of three demontrations
% Script file written by fred harris of SDSU. Copyright 2002


% impulse response
x=zeros(1,5);
x(1)=1;

d1=filter([1 -1],[1 0],x);
d2=filter([1 -1],[1 0],d1);
d3=filter([1 -1],[1 0],d2);
figure(1)
subplot(3,2,1)
stem(d1);
grid
axis([0 6 -1.5 1.5]);
title('impulse response of first stage comb');
subplot(3,2,3)
stem(d2);
grid
axis([0 6 -2.5 2.5]);
title('impulse response of second stage comb');
subplot(3,2,5)
stem(d3);
grid
axis([0 6 -4 4]);
title('impulse response of third stage comb');

zz=zeros(1,5);
d33=reshape([d3;zz;zz;zz;zz;zz;zz;zz;zz;zz;zz;zz;zz;zz;zz;zz],1,80);
s1=filter([1 0],[1 -1],d33);
s2=filter([1 0],[1 -1],s1);
s3=filter([1 0],[1 -1],s2);
ss3=s3;
subplot(3,2,2)
plot(s1);
grid
axis([0 50 -3 3])
title('Impulse response first integrator')
subplot(3,2,4)
plot(s2)
grid;
axis([0 50 -20 20]);
title('Impulse response second integrator')
subplot(3,2,6)
plot(s3);
grid
axis([0 50 -20 220])
title('impulse response third integrator')


% step response
x=ones(1,5);

d1=filter([1 -1],[1 0],x);
d2=filter([1 -1],[1 0],d1);
d3=filter([1 -1],[1 0],d2);
figure(2)
subplot(3,2,1)
stem(d1);
grid
axis([0 6 -1 2]);
title('step response first comb')
subplot(3,2,3);
stem(d2);
grid
axis([0 6 -2 2])
title('step response second comb')
subplot(3,2,5)
stem(d3);
grid
axis([0 6 -3 2]);
title('step response third comb');

zz=zeros(1,5);
d33=reshape([d3;zz;zz;zz;zz;zz;zz;zz;zz;zz;zz;zz;zz;zz;zz;zz],1,80);
s1=filter([1 0],[1 -1],d33);
s2=filter([1 0],[1 -1],s1);
s3=filter([1 0],[1 -1],s2);
subplot(3,2,2)
plot(s1);
grid
axis([0 50 0 1.5])
title('step response first integrator')
subplot(3,2,4)
plot(s2);
grid
axis([0 50 0 20])
title('step response second integrator')
subplot(3,2,6)
plot(s3);
grid
axis([0 50 -20 300])
title('step response third integrator')


% system response
x=sinc(-8:.2:8);
ww=kaiser(81,6);
x=x.*ww';
hh=[ 0.0005   -0.0009   -0.0030   -0.0049   -0.0057   -0.0042   -0.0001...
     0.0055    0.0103    0.0115    0.0074   -0.0018   -0.0130   -0.0210...
    -0.0211   -0.0110    0.0073    0.0268    0.0384    0.0345    0.0130...
    -0.0199   -0.0513   -0.0658   -0.0523   -0.0105    0.0465    0.0956...
     0.1114    0.0776   -0.0033   -0.1071   -0.1916   -0.2105   -0.1292...
     0.0601    0.3316    0.6295    0.8837    1.0298    1.0298    0.8837...
     0.6295    0.3316    0.0601   -0.1292   -0.2105   -0.1916   -0.1071...
    -0.0033    0.0776    0.1114    0.0956    0.0465   -0.0105   -0.0523...
    -0.0658   -0.0513   -0.0199    0.0130    0.0345    0.0384    0.0268...
     0.0073   -0.0110   -0.0211   -0.0210   -0.0130   -0.0018    0.0074...
     0.0115    0.0103    0.0055   -0.0001   -0.0042   -0.0057   -0.0049...
    -0.0030   -0.0009    0.0005];
x=hh;
figure(3)
subplot(2,1,1)
stem(-8:0.2:8-0.2,x)
grid
axis([-9 9 -0.3 1.2])
title('Impulse Response Shaped Pulse')
subplot(2,1,2)
plot([-.5:1/2048:.5-1/2048]*5,fftshift(20*log10(abs(fft(x/sum(x),2048)))));
grid
axis([-2.5 2.5 -80 10])
title('spectra of 1-to-5 shaped pulse')


d1=filter([1 -1],[1 0],x);
d2=filter([1 -1],[1 0],d1);
d3=filter([1 -1],[1 0],d2);

figure(4)
subplot(3,2,1)
plot(d1);
grid
axis([0 80 -0.33 0.33])
title('pulse response first comb')
subplot(3,2,3)
plot(d2);
grid
axis([0 80 -0.17 0.15])
title('pulse response second comb')
subplot(3,2,5)
plot(d3);
grid
axis([0 80 -0.08 0.08])
title('pulse response third comb')

zz=zeros(1,80);
d33=reshape([d3;zz;zz;zz;zz;zz;zz;zz;zz;zz;zz;zz;zz;zz;zz;zz],1,16*80);

s1=filter([1 0],[1 -1],d33);
s2=filter([1 0],[1 -1],s1);
s3=filter([1 0],[1 -1],s2);
subplot(3,2,2)
plot(s1);
grid
axis([0 1300 -0.18 0.15])
title('pulse response first integrator')
subplot(3,2,4)
plot(s2)
grid
axis([0 1300 -5.5 5.5])
title('pulse response second integrator')
subplot(3,2,6)
plot(s3);
grid
axis([0 1300 -100 300])
title('pulse response third integrator')

figure(5)
subplot(2,1,1)
plot([-.5:1/2048:.5-1/2048]*80,fftshift(20*log10(abs(fft(s3/sum(s3),2048)))),'k');
hold on
plot([-.5:1/2048:.5-1/2048]*80,fftshift(20*log10(abs(fft(ss3/sum(ss3),2048)))),'--k');
hold off
grid
axis([-32 32 -110 10]);
title('Spectral Response 1-to-16 3-stage Hogenauer Filter')
ylabel('Log Mag (dB)')
xlabel('Frequency Normalized to Symbol Rate')

subplot(2,1,2)
plot([-.5:1/2048:.5-1/2048]*80,fftshift(20*log10(abs(fft(s3/sum(s3),2048)))),'k');
hold on
plot([-.5:1/2048:.5-1/2048]*80,fftshift(20*log10(abs(fft(ss3/sum(ss3),2048)))),'--k');
hold off
grid
axis([-10 10 -110 10]);
title('Zoom')
ylabel('Log Mag (dB)')
xlabel('Frequency Normalized to Symbol Rate')

