function hogen16c
% hoegennauer filter of order 4, 
% with up-sample ratio 16 from initial 1-to-4 shaping filter
% one of suite of three demontrations
% Script file written by fred harris of SDSU. Copyright 2002

% impulse response
x=zeros(1,5);
x(1)=1;

d1=filter([1 -1],[1 0],x);
d2=filter([1 -1],[1 0],d1);
d3=filter([1 -1],[1 0],d2);
d4=filter([1 -1],[1 0],d3);
plot(d1);hold;plot(d2,'c');plot(d3,'w');plot(d4,'g');hold;axis([0 6 -6 6]);
title('impulse response of four stage integrator');
pause

zz=zeros(1,5);
d33=reshape([d3;zz;zz;zz;zz;zz;zz;zz;zz;zz;zz;zz;zz;zz;zz;zz],1,80);
s1=filter([1 0],[1 -1],d33);
s2=filter([1 0],[1 -1],s1);
s3=filter([1 0],[1 -1],s2);
s4=filter([1 0],[1 -1],s3);
plot(s1);hold;plot(s2,'c');plot(s3,'w');plot(s4,'g');hold;
title('impulse response of 1-to-16 four stage hogenauer')
pause

% step response
x=ones(1,6);

d1=filter([1 -1],[1 0],x);
d2=filter([1 -1],[1 0],d1);
d3=filter([1 -1],[1 0],d2);
d4=filter([1 -1],[1 0],d3);
plot(d1);hold;plot(d2,'c');plot(d3,'w');plot(d4,'g');hold;axis([0 6 -4 4]);
title('step response of four stage integrator');
pause
size(d4)
zz=zeros(1,6);
d44=reshape([d4;zz;zz;zz;zz;zz;zz;zz;zz;zz;zz;zz;zz;zz;zz;zz],1,96);
s1=filter([1 0],[1 -1],d44);
s2=filter([1 0],[1 -1],s1);
s3=filter([1 0],[1 -1],s2);
s4=filter([1 0],[1 -1],s3);
plot(s1);hold;plot(s2,'c');plot(s3,'w');plot(s4,'g');hold;
title('step response of 1-to-16 four stage hoegenauer')
pause

% system response
x=sinc(-8:.25:8);ww=kaiser(65,6);x=x.*ww';
plot([-.5:1/2048:.5-1/2048]*4,fftshift(20*log10(abs(fft(x/sum(x),2048)))));grid
title('specta of 1-to-4 shaped pulse')
pause

d1=filter([1 -1],[1 0],x);
d2=filter([1 -1],[1 0],d1);
d3=filter([1 -1],[1 0],d2);
d4=filter([1 -1],[1 0],d3);
plot(d1);hold;plot(d2,'c');plot(d3,'w');plot(d4,'g');hold;
title('pulse response of four stage integrator')
pause



zz=zeros(1,65);
d33=reshape([d4;zz;zz;zz;zz;zz;zz;zz;zz;zz;zz;zz;zz;zz;zz;zz],1,16*65);

s1=filter([1 0],[1 -1],d33);
s2=filter([1 0],[1 -1],s1);
s3=filter([1 0],[1 -1],s2);
s4=filter([1 0],[1 -1],s3);
plot(s1);hold;plot(s2,'c');plot(s3,'w');plot(s4,'g');hold;
title('pules response of 1-to-16 four stage hoegenauer')
pause

plot([-.5:1/2048:.5-1/2048]*64,fftshift(20*log10(abs(fft(s4/sum(s4),2048)))));grid
axis([-32 32 -120 0]);
title('spectral response 1-to-16 four stage hoegenauer')
pause
axis([-8 +8 -120 0])