function lineardesign_2(action,in1);
% Script file written by Dragan Vultec and fred harris of SDSU. Copyright 2002

global COMPUTE_ 
global ZERO_
global STEP_
global MOVE_UP_
global MOVE_DOWN_
global REITERATE_
global ITERATIONS_
global PLOTRESOLUTION_
global N_
global R_
global wc_
global RESPONSEPLOT
global wr
global mu
global type1
global type2
global currentzero_
global currentstep_
home
if nargin<1,
   close all
   N=4;
   mainfig=figure('name','N-path Linear Phase Allpass Filter Design by Dragan Vuletic and fred harris, SDSU ','numbertitle','off');
   RESPONSEPLOT=axes('units','normalized','position',[0.05 0.5 0.9 0.45]);
   R_ = uicontrol( 'Style','edit','Units','normalized','Position', [0.25 0.05 0.1 0.06],   'String','6');   %================================
   N_ = uicontrol( 'Style','edit','Units','normalized','Position', [0.25 0.12 0.1 0.06],   'String','4','Callback','lineardesign_2(''changeN'')');%=================
   wc_ = uicontrol( 'Style','edit','Units','normalized','Position', [0.25 0.19 0.1 0.06],   'String','0.15');   %================================
   currentzero_ = uicontrol( 'Style','edit','Units','normalized','Position', [0.65 0.04 0.1 0.07],   'String','3');   %================================
   currentstep_ = uicontrol( 'Style','edit','Units','normalized','Position', [0.75 0.04 0.1 0.07],   'String','0.01');   %================================
   ITERATIONS_ = uicontrol( 'Style','edit','Units','normalized','Position', [0.25 0.26 0.1 0.06],   'String','20');   %================================
   PLOTRESOLUTION_ = uicontrol( 'Style','edit','Units','normalized','Position', [0.25 0.33 0.1 0.06],   'String','300');   %================================
   Rtext = uicontrol( 'Style','text','Units','normalized','Position', [0.01 0.05 0.23 0.060],   'String','No of coefficients');   %================================
   Ntext = uicontrol( 'Style','text','Units','normalized','Position', [0.01 0.12 0.23 0.060],   'String','No of Paths');   %================================
   wctext = uicontrol( 'Style','text','Units','normalized','Position', [0.01 0.19 0.23 0.060],   'String',['wc from ' num2str(0.5/N) ' to ' num2str(1/N)]);   %=======
   ITERATIONStext = uicontrol( 'Style','text','Units','normalized','Position', [0.01 0.26 0.23 0.060],   'String','iterations');  %================================
   PLOTRESOLUTIONtext = uicontrol( 'Style','text','Units','normalized','Position', [0.01 0.33 0.23 0.060],   'String','resolution');   %============================
   COMPUTE_=uicontrol('Style','push','Units','normalized','Position',[0.45 0.25 0.1 0.1],'String','Compute!','Callback','lineardesign_2(''start'')');   
   REITERATE_=uicontrol('Style','push','Units','normalized','Position',[0.45 0.10 0.1 0.1],'String','Reiterate!','Callback','lineardesign_2(''start'',''reiterate'')');   
   MOVE_=uicontrol('Style','push','Units','normalized','Position',[0.68 0.15 0.15 0.08],'String','Move Zero','Callback','lineardesign_2(''start'',''movezeros'')');   
   readtext1=uicontrol('style','text','units','normalized','position',[0.60 0.35 0.30 0.05],'string','Highlight Parameter Value');
   readtext2=uicontrol('style','text','units','normalized','position',[0.60 0.30 0.30 0.05],'string','Enter Desired Value');
   readtext2=uicontrol('style','text','units','normalized','position',[0.60 0.25 0.30 0.05],'string','Depress Button');

   action='start';
end;
if nargin<2
   in1=['  dont   '];
end

if strcmp(action,'start'),
   cla   
   R=str2num(get(R_,'string'));   
   N=str2num(get(N_,'string'));
   ITERATIONS=str2num(get(ITERATIONS_,'string'));
   PLOTRESOLUTION=str2num(get(PLOTRESOLUTION_,'string'));
   RESOLUTION=N*R*10;
 
   if in1~='reiterate'& in1~='movezeros'
      wc=str2num(get(wc_,'string'));
      if wc<0.5/N
          wc=1.2*wc;
      set(wc_,'string',num2str(wc));
      end
      if wc>1/N
         wc=(1/N)/1.2;
      set(wc_,'string',num2str(wc));   
      end
      
      wc=2/N-2*wc;
      wc=wc*pi;
      wr=[];
         for d=1:R                    %%%%%%%%%% pick starting wr and mu
         wr=[wr d/R*wc];
      end
      mu=wc/100/R*[ones(1,length(wr)-1) 0];% 0 for wc cutoff
   end
   if in1~='movezeros' 
      for ggg=1:ITERATIONS
         response=getResponse(N,R,wr,RESOLUTION);
         %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
         %      plot(0:1/N/length(response):1/N-1/N/length(response),response,'color',[0.1 0.5 1/ggg]);
         
         direction=getNewwr(wr*N/2,response,RESOLUTION,N);
         direction2(mod(ggg,5)+1,:)=getNewwr(wr*N/2,response,RESOLUTION,N);      
         %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% adaptive step update part %%%%%%%%%%%%%%%%%%%%%%%%%%%%
         if mod(ggg,5)==0  %every five iterations do mu update
            d=sum(direction2);
            for q=1:length(d)-1
               if abs(d(q))<5 
                  mu(q)=0.95*mu(q);
               end
            end
         end
         %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% adaptive step update part end %%%%%%%%%%%%%%%%%%%%%%%%%%%%
         
         wr=wr+direction.*mu;
         
      end
   else
      wr(R-str2num(get(currentzero_,'string'))+1)=wr(R-str2num(get(currentzero_,'string'))+1)*(1-0.5*str2num(get(currentstep_,'string')));
      set(wc_,'string',num2str(2/N-wr(length(wr))/pi));

   end
   gPZDen=plotAll(N,R,wr,PLOTRESOLUTION);   
   
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%  calculate & display coefficients
   
   type1=[];
   type2=[];
   home
   format long
   
   dly=N*R;
   disp(' ')
      disp(['Roots = ' ])
      disp(' ')
      disp(['  ',num2str(dly),' Poles at Origin'])
      disp(' ')
      disp(['  branch 0 - ',num2str(dly), ' Delays,     ', 'Z^(-',num2str(dly),')'])
      disp('  ')
   for C=1:N-1   
      [type1 type2]=polyToCoef(gPZDen(C,1:N:length(gPZDen)));
         disp([ '  branch ',num2str(C,16), ' - type1     coefficient    ',num2str(type1(1,:),16)]);
      if ~isempty(type2)
         disp([ '  branch ',num2str(C,16), ' - type2 1st coefficient    ',num2str(-type2(:,1)',16)]);
         disp([ '  branch ',num2str(C,16), ' - type2 2nd coefficient    ',num2str(type2(:,2)',16)]);
         disp('			');
      end
   end
   
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   
elseif strcmp(action,'changeN'),
   N=str2num(get(N_,'string'));
   wctext = uicontrol( 'Style','text','Units','normalized','Position', [0.01 0.19 0.23 0.060],   'String',['wc from ' num2str(0.5/N) ' to ' num2str(1/N)]);   %===
   wc=1.05/N;  
   set(wc_,'string',num2str(wc/2));
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

   
