function gPZDen=plotAll(N,R,wr,PLOTRESOLUTION);
% Script file written by Dragan Vultec and fred harris of SDSU. Copyright 2002

	poles=[zeros(1,N*R)'];
   for i=1:N-1
      n=i;
      [gPZNum(i,:),gPZDen(i,:)]=getZfunction(N,R,n,wr);
      NN=[zeros(1,i) gPZNum(i,:)];
      NNN(i,:)=[zeros(1,i) gPZNum(i,:) zeros(1, N-i-1)];
      poles=[poles roots(gPZDen(i,:))];
      H1(i,:)=freqz(NN,gPZDen(i,:),0:pi/PLOTRESOLUTION:pi-pi/PLOTRESOLUTION);
      I(i,:)=filter(NN,gPZDen(i,:),[1 zeros(1,N*R*20)]);
    end
   
   for r=2:N
        den_t=1;
        for n=1:N*R
        den_t=conv(den_t,[1 poles(n,r)]);
        end
        denom(r,:)=den_t;
    end
  
    num=zeros(1,N*R*(N-1)+(N-1));
    for r=2:N
        dly1=zeros(1,N-r);
        dly2=zeros(1,r-2);
        num_t=[1 dly1];
        for n=2:N
            if n==r
                num_t=conv(num_t,fliplr(denom(n,:)));
            else
                num_t=conv(num_t,denom(n,:));
            end
        end
        num=num+[dly2 num_t];
    end
    
    dly=zeros(1,N-1);
    den_t=[1 dly];
        for n=2:N
            den_t=conv(den_t,denom(n,:));
        end
        
    num_final=[zeros(1,N*R-1) den_t]+conv(num,[1 zeros(1,N*R)]);
  
   N0=[zeros(1,N*R) 1];
   H00=freqz(N0,1,0:pi/PLOTRESOLUTION:pi-pi/PLOTRESOLUTION); % delay
   I1=filter(N0,1,[1 zeros(1,N*R*20)]);
   N00=[zeros(1,N*R) 1 zeros(1,N-1)];
   if N>2
   II=(sum(I)+I1);
   else
   II=(I+I1);
   end
   
   figure(3)
   plot(II);title('Impulse Response');
   grid on
   zoom on
   
   figure(4)
   plot(0:0.5/length(I):0.5-0.5/length(I),grpdelay(II,1,length(I)));title('Group Delay');
   grid on
   zoom on
   
   figure(5)   
   if N>2
   plot(0:0.5/length(H1):0.5-0.5/length(H1),unwrap(angle(sum(H1)+H00)));title('Phase Response');
   else
   plot(0:0.5/length(H1):0.5-0.5/length(H1),unwrap(angle((H1)+H00)));title('Phase Response');
	end
	grid on
   zoom on
   zzeros=[];
   for SS=1:floor((N-1)/2)
      zzeros=[zzeros 2*pi*SS/N-wr 2*pi*SS/N+wr -2*pi*SS/N-wr -2*pi*SS/N+wr];
   end
   zzeros=[zzeros pi-wr wr-pi];
   zzeros=exp(-j*zzeros);
   
   figure(2); 
   plot(roots(num_final),'ro','markersize',6,'linewidth',2)
   hold on
   plot(roots(den_t),'rx','markersize',8,'linewidth',2)
   plot(zzeros,'o','markersize',6,'linewidth',2)
   plot(exp(j*2*pi*(0:.01:1)))
   hold off
   grid
   axis(['square'])
   tst=max(real(roots(num_final)));
   axis([-1.2  1.2  -1.2  1.2]*tst)
   title('Pole-Zero Diagram');
   
   if N>2
      response=20*log10(1/N*(abs(sum(H1)+H00)));
   else
      response=20*log10(1/N*(abs(H1+H00)));
   end
   
   figure(1);
	plot(0:0.5/length(H1):0.5-0.5/length(H1),response,'r');
	title(['Normalized Passband Frequency is  ' num2str(0.5/N)]);
   axis([0 0.5 -100 5])
   grid on
   zoom on
